#include <colors> 
#include <geoip> 
#include <cstrike>
#include <basecomm>

#define PLUGIN_VERSION "1.5"

new Handle:Spam_Timer[MAXPLAYERS+1];
new Spam_max[MAXPLAYERS+1];

new bool:g_bSayHook[MAXPLAYERS+1];

// Квары - Cvars
new bool:g_bChatTag = true;
new bool:g_bClanTag = true;

public Plugin:myinfo = 
{
	name = "[CS:GO] Country Tag",
	author = "Danyas & Hejter",
	description = "Add in chat and in scoreboard country tag.",
	version = PLUGIN_VERSION,
	url = "http://www.excw.ru"
}

public OnPluginStart()
{
    new Handle:hRegister; // Локальный handle для регистрации ConVar'ов

    CreateConVar("country_tag_version", PLUGIN_VERSION, "Country Tag Version.", FCVAR_DONTRECORD|FCVAR_PLUGIN|FCVAR_SPONLY|FCVAR_REPLICATED|FCVAR_NOTIFY);

    // Сразу будем отслеживать изменения и зарегистрируем переменную 
    HookConVarChange((hRegister = CreateConVar("chat_tag", "1", "on/off set country_chat tag in chat (ВКЛ/ВЫКЛ показ страны в чате)", _, true, 0.0, true, 1.0)), OnChatTagChange); 
    g_bChatTag = GetConVarBool(hRegister); // Мгновенно присвоим значение для глобального буля 
	
    // Вторая переменная - Second variable
    HookConVarChange((hRegister = CreateConVar("clan_tag", "1", "on/off set country_clan tag in scoreboard (ВКЛ/ВЫКЛ показ страны в таблице (клантег))", _, true, 0.0, true, 1.0)), OnClanTagChange); 
    g_bClanTag = GetConVarBool(hRegister); // Convars by KyleS

    AddCommandListener(say, "say"); 
    AddCommandListener(say, "say_team");

    //  Отлов события "ВОЗРОЖДЕНИЕ ИГРОКА"  - HookEvent player_spawn
    HookEvent("player_spawn", Event_OnPlayerSpawn, EventHookMode_Post);
	
    LoadTranslations("csgo_country.phrases");
	
	//exec country_tag.cfg
    AutoExecConfig(true, "country_tag");
	
    CloseHandle(hRegister); // Закрывает утечку памяти - Closes a memory leak.
}

public OnChatTagChange(Handle:convar, const String:oldValue[], const String:newValue[]) 
{ 
    g_bChatTag = GetConVarBool(convar); 
}

public OnClanTagChange(Handle:convar, const String:oldValue[], const String:newValue[]) 
{ 
    g_bClanTag = GetConVarBool(convar); 
}

public Action:spamprot(Handle:timer, any:client) 
{ 
	Spam_max[client] = 0;
}

public Action:SetClanTag(Handle:timer, any:client)
{
	if (!IsValidClient(client) || IsFakeClient(client))
		return;

	decl String:ip[14], String:tag[3];
	GetClientIP(client, ip, 13); 
	GeoipCode2(ip, tag);
	CS_SetClientClanTag(client, tag);
}

public Action:say(client, const String:command[], args) 
{
    if(g_bChatTag)
	{
	g_bSayHook[client]=true;
	if (IsValidClient(client))
	{
	if (BaseComm_IsClientGagged(client)) {PrintToChat(client, "%t", "MUTE"); return Plugin_Handled;}
	decl String:ip[14], String:tag[3],String:text[1024];
	text[0] = '\0';
	new team = GetClientTeam(client);
	new alive = IsPlayerAlive(client);
	GetClientIP(client, ip, 13); 
	if (!GeoipCode2(ip, tag)) tag = "??";
	if(Spam_max[client] > 1){return Plugin_Handled;}
	Spam_max[client]++;
	Spam_Timer[client] = CreateTimer(3.0, spamprot, client); 
	if (client == 0 && args < 2) return Plugin_Continue;
	
	GetCmdArgString(text, sizeof(text));
	StripQuotes(text);
	TrimString(text);
	//пустое сообщение - empty message
	if(StrEqual(text, " ") || StrEqual(text, "")) {g_bSayHook[client]=false;return Plugin_Handled;}
	if ( strlen(text) == 0 ) return Plugin_Handled;
	if(StrContains(text, "@") == 0 || StrContains(text, "/") == 0) return Plugin_Continue;
	//if((IsChatTrigger() && text[0] == '/') || (text[0] == '@' && (GetUserFlagBits(client) & ADMFLAG_ROOT ||  GetUserFlagBits(client) & ADMFLAG_GENERIC))){g_bSayHook[client]=false;return Plugin_Continue;}
	
	if ( strcmp(command, "say_team"))
	{
		if (team < 2) Format(text, sizeof(text) ,"%t", "SPECTATOR_SAY_TEAM", tag, client, text);
		else
		{
			if (alive) Format(text, sizeof(text), "%t", "ALIVE_CHAT", tag, client, text);
			else Format(text, sizeof(text),"%t", "DEAD", tag, client, text);
		}
		CPrintToChatAllEx(client, "%s", text);
		return Plugin_Handled;
	}
	
	else if(strcmp(command, "say") == 0)
	{
		if (team < 2)
			{
				Format(text, sizeof(text),"%t", "SPECTATOR_SAY", tag, client, text); 
				CPrintToChatAllEx(client, "%s", text);
			}
			else
			{
				if(team == 3)
				{
					if (alive) Format(text, sizeof(text), "%t", "TEAM_CT", tag, client, text);
					else Format(text, sizeof(text), "%t", "%t", "DEAD_TEAM_CT", tag, client, text);	
				}
				else
				{
					if (alive) Format(text, sizeof(text), "%t", "TEAM_T", tag, client, text); 
					else Format(text, sizeof(text), "%t", "DEAD_TEAM_T", tag, client, text);				
				}
				for (new x = 1; x <= MaxClients; x++)
				{
				    if (IsClientInGame(client))
                    {
					    if (GetClientTeam(x) == team)
					    {
						    CPrintToChatEx(x, x, "%s", text);
					    }
				    }
			    }
			}
		}
        return Plugin_Handled;
	}
	}
    return Plugin_Continue;
}

// "ВОЗРОЖДЕНИЕ ИГРОКА" - player_spawn
public Action:Event_OnPlayerSpawn(Handle:event, const String:name[], bool:dontBroadcast)
{
    if(g_bClanTag)
	{
	    new client = GetClientOfUserId(GetEventInt(event, "userid"));
	    if(client != 0)
	    {	
		    PlayerSpawn(client);
	    }
	}
    return Plugin_Continue;
}

PlayerSpawn(client)
{
	if (!IsValidClient(client))
		return;

	//установка клан тэга - set clan tag
	CreateTimer(1.5, SetClanTag, client,TIMER_FLAG_NO_MAPCHANGE);		
}

stock bool:IsValidClient(client)
{
    if(client >= 1 && client <= MaxClients && IsValidEntity(client) && IsClientConnected(client) && IsClientInGame(client))
        return true;  
    return false;
}